unit rstring;

{<
  rstring is unit containing all resource strings.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Apr 2006)
  @lastmod(Lun 2015)
}

interface




resourcestring

  // ***************************************************
  // COMMON STRING

  // Actions
  { }
  sInitialize = 'Initialiseren';
  sBrowsing = 'Bladeren';
  sEditing = 'Bewerken';
  sInserting = 'InVoegen';
  sLoading = 'Laden';
  sCreating = 'Creeren';
  sPrinting = 'Afdrukken';
  sExporting = 'Exporteren';
  sLookingFor = 'Zoeken...';
  sWaiting = 'Wachten';
  sChecking = 'Controleren';
  sImporting = 'Importeren';
  sOfData = ' van gegevens...';

  // Questions
  { }
  sContinueQ = 'Doorgaan?';
  sTerminateQ = 'Beeindigen?';
  sCancelQ = 'Annuleren?';
  sDeleteQ = 'Verwijderen?';
  sOverwriteQ = 'Overschrijven?';
  sTryAgainQ = 'Try again?';
  sSetDefaultValues = 'Reset naar standaard waarden?';
  sSaveChangesQ = 'Veranderingen opslaan?';
  sUseChangesQ = 'gebruik veranderingen?';
  sUseFilterQ = 'Gebruik gekozen filter?';

  // File and dir
  { }
  sFile = 'Bestand "%s".';
  sFileNotFound = 'Bestand "%s" niet gevonden.';
  sDirNotFound = 'Directory "%s" niet gevonden.';
  sFileExist = 'Bestand "%s" bestaat al.';
  sDirExist = 'Directory "%s" bestaat al.';
  sFileSaved = 'Bestande "%s" is opgeslagen.';
  sFileOpenQ = 'Open bestand "%s"?';
  sOpenOtherFileQ = 'Open ander bestand?';
  sOpenLastFileQ = 'Open origineel bestand?';

  // File error
  { }
  sMakeDirErr = 'Kan doel directory niet maken "%s".';
  sFilePrintErr = 'Kan bestand niet afdrukken "%s".';
  sFileOpenErr = 'kan bestand niet openen "%s".';
  sFileOpenErr2 = 'Bestand bestaat niet (waarschijnlijk).';
  sFileSaveErr = 'Fout tijdens opslaan "%s".';
  sFileSaveErr2 = 'U heeft niet de rechten, doel directory' + ' bestaat niet of doel bestand is geopenend in andere applicatie.';
  sDLLNotFound = 'Dynamic library "%s" niet gevonden.';

  // File types
  { }
  sFileTypeAll = 'Alle bestanden (*.*)|*.*';
  sFileTypeTXT = 'Tekst bestand (*.txt)|*.txt';
  sFileTypeSLK = 'Symbolic connection file (*.slk)|*.slk';
  sFileTypeRTF = 'Rich text format (*.rtf)|*.rtf';
  sFileTypeDOC = 'MSWord document (*.doc)|*.doc';
  sFileTypeDOCX = 'MSWord document (*.docx)|*.docx';
  sFileTypeODT = 'Open document format (*.odt)|*.odt';
  sFileTypeXLS = 'Excel bestand (*.xls)|*.xls';
  sFileTypeMDB = 'Database MS Access (*.mdb)|*.mdb';
  sFileTypeSQL = 'SQL command (*.sql)|*.sql';
  sFileTypeDBF = 'dBase bestand (*.dbf)|*.dbf';
  sFileTypePDF = 'PDF bestand (*.pdf)|*.pdf';
  sFileTypeBMP = 'Bitmaps (*.bmp)|*.bmp';
  sFileTypeJPG = 'Jpeg bestand (*.jpg;*.jpeg)|*.jpg;*.jpeg';
  sFileTypePNG = 'PNG bestand (*.png)|*.png';
  sFileTypeBMPJPG = 'Graphics formaten (*.bmp;*.jpg;*.jpeg)|*.bmp;*.jpg;*.jpeg';
  sFileTypeBMPJPGPNG = 'Graphics formaten (*.bmp;*.jpg;*.jpeg;*.png)|*.bmp;*.jpg;*.jpeg;*.png';

  // Error descriptions
  { }
  sErrorDescription = 'Fout beschrijving:';
  sRuntimeErr = 'Runtime error.';
  sRaiseErr = 'Onverwachte fout. Sluit applicatie en probeer opnieuw.';


  // Format error
  { }
  sInputErr = 'Fout in invoerparameters.';
  sFormatNumberErr = 'Foutief nummer.';
  sFormatDateErr = 'Verkeerde datum.';
  sFormatYearErr = 'Foutief jaar formaat.';
  sDateIntervalErr = 'Verkeerde periodedatum.';
  sExpressionErr = 'Foutieve expressie.';
  sPictureErr = 'Foutief foto formaat.';

  // Other
  { }
  sAborted = 'Actie afgebroken.';
  sTerminate = 'Programma wordt beeindigd.';
  sNotRegist = 'Programma is niet geregistreerd.';
  sNotImplement = 'Deze actie is nog niet beschikbaar.';
  sNotSupported = 'Deze functie is nog niet beschikbaar.';
  sVersion = 'Versie';
  sAllOK = 'Alles OK.';
  sYes = 'Ja';
  sNo = 'Nee';
  sOK = 'Ok';
  sCancel = 'Annuleren';

  sWrongPsw = 'Foutief wachtwoord.';
  sMailErr = 'Fout met zenden E-mail.';
  sMailGenInfo = 'Genereren van e-mail...';

  // ***************************************************
  // DATABASE STRING

  // DB action
  { }
  sConnecting = 'Connectie naar database...';
  sLogging = 'Logging naar database...';
  sInactive = 'Inactief';
  sRecord = 'record';
  sNumRecords = '%d records';
  sSelRecords = 'geselecteerde %d records.';

  // DB questions
  { }
  sDelRecordQ = 'Verwijder geselecteerd record?';
  sDelMultipleRecordQ = 'Delete all selected records?';

  // DB error
  { }
  sConnectDataErr = 'Fout bij Connectie naar database "%s"';
  sCreateDataErr = 'Fout: kan data niet creeeren.';
  sOpenDataErr = 'Fout: kan data niet openen.';
  sReadDataErr = 'Fout: Kan data niet lezen.';
  sSaveDataErr = 'Fout: Kan data niet opslaan.';
  sCompressDataErr = 'Fout: kan data niet comprimeren.';
  sExportDataErr = 'Fout: kan data niet exporteren.';
  sImportDataErr = 'Fout: kan data niet importeren.';
  sDecodeDataErr = 'kan data niet decoderen.';
  sSaveRecordErr = 'Fout: kan record niet opslaan.';
  sOpenTableErr = 'Fout: kan tabel niet openen "%s".';
  sEditRecordErr = 'Fout: kan record niet bewerken.';
  sSortDataErr = 'Fout: Sortren van data.';
  sNoSavedItems = 'Geen opgeslagen items';
  sInputItemName = 'Naam van opgeslagen item:';

  // Find results
  { }
  sNotFound = 'Niet gevonden';
  sFound = 'Gevonden';

  sFilterName = 'Filter naam';
  sFilterString = 'Filter conditie';

  sEndEditing = 'Bewerken van record voltooien.';

  // ***************************************************
  // UNIT rdlg

  { }
  sInformation = 'Informatie';
  sQuestion = 'Vraag';
  sWarning = 'Waarschuwing';
  sInput = 'Ingave';
  sError = 'Fout';
  sBtOk = '&Ok';
  sBtYes = '&Ja';
  sBtNo = '&Nee';
  sBtCancel = '&Annuleren';
  sCut = 'Knippen';
  sCopy = 'Kopieren';
  sPaste = 'Plakken';
  sDelete = 'Delete';
  sUndo = 'Undo';
  sSelectAll = 'Select all';
  sSaveToFile = 'Bestand opslaan..';
  sLoadFromFile = 'Bestand openen..';
  sFind = 'Encontrar';
  sFindNext = 'Encontre o prximo';
  sChangeFont = 'Alterar fonte';
  sAbort = 'Abortar';

  // ***************************************************
  // UNIT RTFReport

  { }
  sReport = 'Rapport';
  sTemplateFormatErr = 'Verkeerd formaat van RTF bestand.';
  sPrinterNotFound = 'Printer "%s" niet gevonden.';

  sTemplateBracketErr = 'Ongeldig teken in formule: "%s".';
  sTemplateFieldErr = 'Calculatie fout in databaseveld "%s".';
  sTemplateDatasetErr = 'Incorrect dataset "%s", (A..Z toegestaan)';
  sTemplateTagNotFoundErr = '"%s" niet gevonden.';
  sTemplateCalculationErr = 'Calculatie fout in functie "%s".';
  sTemplateIncorrectTag = 'Incorrect label "%s".';

  sCreatingReport = 'Genereren van rapport...';
  sCreatingReportErr = 'fout tijdens genereren van rapport.';
  sFileGeneration = 'Genereren van bestand %s...';
  sPDFWaitAgainQ = 'uitvoerbestand is nog niet gegenereerd. Wilt u wachten?';
  sPDFConfiguration = 'PDF printer configuratie...';
  sPDFConfigurationErr = 'Fout tijdens PDF printer configuratie.';
  sDeleteOldFileErr = 'Uitvoerbestand %s bestaat reeds en kan niet worden overschreven.';

  // OLE
  sMSWordNotFound = 'MSWord applicatie niet gevonden.';
  sMSWordError = 'MSWord applicatie fout.';
  sMSExcelNotFound = 'MSExcel applicatie niet gevonden.';
  sMSExcelError = 'MSExcel applicatie fout.';
  sMSExcelRunningToClose = 'MSExcel applicatie zal worden afgesloten en bestand is gewijzigd. Veranderingen opslaan?';

  // ***************************************************
  // rDBGrid unit
  { }
  sPMSum = 'Som = %sum';
  sPMMin = 'Min = %min';
  sPMMax = 'Max = %max';
  sPMAvg = 'Avg = %avg';
  sPMCountVal = 'Count of values = %CountVal';
  sPMCountNull = 'Count of empty = %CountNull';
  sPMCountAll = 'Count of all = %CountAll';

  sSelectAllRecords = 'Selecteer alle records';
  sDeselectAllRecords = 'Deselecteer alle records';
  sReverseSelection = 'Keer selectie om';
  sDeleteSelectedRecords = 'Verwijder geselecteerde records';
  sNoRecordsSelected = 'geen record geselecteerd.';
  sSelectedNumRecContinueQ = 'Er waren al records geselecteerd %d , Doorgaan?';

  sCellParamsCondErr='Ongeldige conditie voor veld %s. Conditie zal worden gedeactiveerd.';
  sCellParamsCondStart='start bij';
  sCellParamsCondNotStart='start niet bij';
  sCellParamsCondContain='bevat';
  sCellParamsCondNotContain='bevat niet';
  sCellParamsCondAllways='altijd';
  sCellParamsActSet='>>>';
  sCellParamsActAND='En';
  sCellParamsActOR='Of';

  sFilterSelectAll = '(selecteer alles)';
  sFilterNullValue = '(Leegmaken)';
  sIndicatorColumnName = '- Row header -';

  // ***************************************************
  // rDBComponent unit
  { }
  sPictureEmpty = '(leegmaken)';
  sPictureCorrupted = '(corrupted)';
  sSaveInJPEGFormat = 'Opslaan in JPG formaat';
  sPictureResize = 'Verander resolutie';
  sResizeRatioQ = 'Aanpassen grootte in percentage (1% - 500%):';
  sZoomAutoFit = 'Zoom - scherm';
  sZoomIn = 'Zoom in';
  sZoomOut = 'Zoom uit';
  sZoom = 'Zoom';
  sShowPicEdit = 'Bewerk in nieuw schermwindow (helderheid, contrast)';
  sPicConvert = 'Convert...';
  sPicConvertJPG1 = 'Huidig record naar JPG';
  sPicConvertBMP1 = 'Huidig record naar BMP';
  sPicConvertJPGAll = 'alle records naar JPG';
  sPicConvertBMPAll = 'alle records naar BMP';
  sPicConvertAllQ = 'Deze veranderingen toepassen op alle velden van de tabel.';
  sPicConvertProcess = 'Converteren...';
  sBlobOpen = 'Openen';
  sBlobLoad = 'Laden';
  sBlobSave = 'Opslaan';
  sBlobClear = 'Leegmaken';
  sBlobRename = 'Verander bestandsnaam';
  sBlobChangeExtQ = 'Wilt u bestandstype wijzigen (extensie)? Dit kan effect hebben op de leesbaarheid van het bestand.';
  sBlobFileOverLimitQ = 'Grootte van geselecteerd bestand (%f MB) overschrijd limietgroote (%f MB).';

  sFormatInfo = 'Formaat geselecteerde tekst';
  sFormatBold = 'Vet';
  sFormatItalic = 'Cursief';
  sFormatUnderline = 'Onderstreept';
  sFormatAsUnnumberedList='Unnumbered list';
  sFormatAsNumberedList='Numbered list';
  sFormatNewPage = 'Voeg pagina einde toe';
  sFormatNewLine2 = 'Voeg eind toe aan lijn';
  sFormatNewLineAuto='Voeg eind toe aan alle lijnen';
  sFormatHorLine = 'Voeg horizontale lijn toe';
  sFormatHTMLLink = 'Voeg HTML link toe';
  sFormatClear = 'maak alle formaten leeg';
  sEditInfo = 'Toon op scherm';

  // ***************************************************
  // rDBMemoGrid unit
  { }
  mnDelRow = 'Verwijder rij';
  mnMoveUpRow = 'Rij omhoog';
  mnMoveDownRow = 'Rij omlaag';
  mnCopyCell = 'Kopieer cel';
  mnPasteCell = 'Plak cel';
  mnCopyTable = 'Kopieer gehele tabel';
  mnPasteTable = 'Plak gehele tabel';
  mnAppendTable = 'Voeg hele tabel toe';
  mnClearTable = 'Maak tabel leeg';
  mnSelectRow = 'Selecteer rij';
  mnSelectAll = 'Selecteer alle rijen';
  mnSelectCol = 'Selecteer kolom';
  mnSelectCell = 'Selecteer cel';
  mnDeselectAll = 'Annuleer selectie';

  // ***************************************************
  // rDBPrint unit
  { }
  sPrintToomuchCols = 'Data to print is too wide, unselect some columns or select smaller font size.';
  sPrintRecCount='Total count of records: %d';
  sPrintPreviewLimit = 'Preview is limited to 60 pages.';

  // ***************************************************
  // rpictool unit
  { }
  sColorBlack = 'Zwart';
  sColorBlackLoc = 'Zwart';
  sColorMaroon = 'Maroon';
  sColorMaroonLoc = 'Maroon';
  sColorGreen = 'Groen';
  sColorGreenLoc = 'Groen';
  sColorOlive = 'Olijf';
  sColorOliveLoc = 'Olif';
  sColorNavy = 'Navy';
  sColorNavyLoc = 'Navy';
  sColorPurple = 'Paars';
  sColorPurpleLoc = 'Paars';
  sColorTeal = 'Teal';
  sColorTealLoc = 'Teal';
  sColorGray = 'Grijs';
  sColorGrayLoc = 'Grijs';
  sColorSilver = 'Zilver';
  sColorSilverLoc = 'Zilver';
  sColorRed = 'Rood';
  sColorRedLoc = 'Rood';
  sColorLime = 'Lime';
  sColorLimeLoc = 'Lime';
  sColorYellow = 'Geel';
  sColorYellowLoc = 'Geel';
  sColorBlue = 'Blauw';
  sColorBlueLoc = 'Blauw';
  sColorFuchsia = 'Fuchsia';
  sColorFuchsiaLoc = 'Fuchsia';
  sColorAqua = 'Aqua';
  sColorAquaLoc = 'Aqua';
  sColorWhite = 'Wit';
  sColorWhiteLoc = 'Wit';

  sColorMoneyGreen = 'MoneyGreen';
  sColorMoneyGreenLoc = 'Money Green';
  sColorSkyBlue = 'SkyBlue';
  sColorSkyBlueLoc = 'Sky Blue';
  sColorCream = 'Cream';
  sColorCreamLoc = 'Cream';
  sColorMedGray = 'MedGray';
  sColorMedGrayLoc = 'Med Gray';

  sColorCustom = 'Aangepast...';
  sColorCustomLoc = 'Aangepast...';

implementation

end.
