unit rDBGrid_DTEdit;

{<
  rDBGrid_DTEdit is design time dialog used by rDBGrid component.

  Updated version compatible with Delphi2010+.
  Full functional demo.
  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(May 2006)
  @lastmod(Oct 2014)
}

interface
{$INCLUDE _delphi_ver.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DBGrids, rDBGrid, db, CheckLst, ComCtrls,
  {$IFDEF DXE2P} UITypes, Types, {$ENDIF}
  ExtCtrls, IniFiles, rImprovedComps, PropSaveMain, Grids, rHTMLLabel;

type
  { design time dialog used by rDBGrid component }
  TrDBGrid_DTEditForm = class(TForm)
    pc: TPageControl;
    tsCol: TTabSheet;
    tsTag: TTabSheet;
    gbActions: TGroupBox;
    gbEdit: TGroupBox;
    chAdd: TCheckBox;
    chEdit: TCheckBox;
    chDuplic: TCheckBox;
    chDelete: TCheckBox;
    chSaveAdd: TCheckBox;
    chAutoEdit: TCheckBox;
    chEditGroup: TCheckBox;
    gbTools: TGroupBox;
    chSort: TCheckBox;
    chFilter: TCheckBox;
    chColumn: TCheckBox;
    chClose: TCheckBox;
    chEnaAll: TCheckBox;
    tsLink: TTabSheet;
    Label10: TLabel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    chProps: TCheckBox;
    PSFile: TPropSaveFile;
    PSMain: TPropSaveMain;
    gbEmpty: TrGroupBox;
    btClose: TButton;
    gbLeft1: TrGroupBox;
    Label1: TLabel;
    lbFields: TListBox;
    btMove: TButton;
    btMoveAll: TButton;
    Label3: TLabel;
    eSep: TEdit;
    gbRight1: TrGroupBox;
    Label2: TLabel;
    lbCol: TCheckListBox;
    btUp: TButton;
    btDown: TButton;
    btDel: TButton;
    btDelAll: TButton;
    btDelNoField: TButton;
    gbColBottom: TrGroupBox;
    lFld: TLabel;
    lTitle: TLabel;
    eTitle: TEdit;
    chReadOnly: TCheckBox;
    btNext: TButton;
    lblFName: TLabel;
    gbLeft2: TrGroupBox;
    gbRight2: TrGroupBox;
    Label6: TLabel;
    lbLink: TCheckListBox;
    Label12: TLabel;
    cbLinkType: TComboBox;
    Label19: TLabel;
    Label7: TLabel;
    lbBool: TCheckListBox;
    Label8: TLabel;
    Label20: TLabel;
    eBoolVal: TEdit;
    Label9: TLabel;
    gbLeft3: TrGroupBox;
    gbRight3: TrGroupBox;
    Label11: TLabel;
    lbPick: TCheckListBox;
    Label24: TLabel;
    lbColor: TCheckListBox;
    gbLeft4: TrGroupBox;
    gbRight4: TrGroupBox;
    Label13: TLabel;
    lbTitleImg: TCheckListBox;
    Label17: TLabel;
    Label18: TLabel;
    cbDataImg: TComboBox;
    lbDataImg: TListBox;
    btDAdd: TButton;
    btDDel: TButton;
    rGroupBox2: TrGroupBox;
    Label14: TLabel;
    eTitleImg: TrEditNum;
    UpDownTitleImg: TUpDown;
    TitleImg: TImage;
    rGroupBox3: TrGroupBox;
    DataImg: TImage;
    lDataImgVal: TLabel;
    lDataImgIdx: TLabel;
    Label22: TrHTMLLabel;
    lDataImgText: TLabel;
    eDataImgVal: TComboBox;
    eDataImgIdx: TrEditNum;
    UpDownDataImg: TUpDown;
    eDataImgText: TEdit;
    Label4: TLabel;
    TabSheet3: TTabSheet;
    lbDrawPick: TCheckListBox;
    Label5: TLabel;
    rHTMLLabel1: TrHTMLLabel;
    gbLeft5: TrGroupBox;
    Label15: TLabel;
    lbDate: TCheckListBox;
    gbRight5: TrGroupBox;
    Label21: TLabel;
    Label23: TLabel;
    lbGraphics: TCheckListBox;
    Label16: TLabel;
    TabSheet4: TTabSheet;
    gbRight6: TrGroupBox;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    lbHints: TCheckListBox;
    eHint: TEdit;
    gbLeft6: TrGroupBox;
    Label28: TLabel;
    Label30: TLabel;
    lbFilterFields: TCheckListBox;
    btCollapse: TButton;
    btExpand: TButton;
    tsGroup: TTabSheet;
    gbLeftGroups: TrGroupBox;
    Label29: TLabel;
    lbGroups: TListBox;
    btNewGroup: TButton;
    btDelGroup: TButton;
    gbGroupBottom: TrGroupBox;
    Label31: TLabel;
    eGroupTitle: TEdit;
    cgGroupTitleColor: TColorBox;
    Label32: TLabel;
    gbRightGroups: TrGroupBox;
    Label33: TLabel;
    lbGroupFields: TCheckListBox;
    btGroupUpdate: TButton;
    rGroupBox1: TrGroupBox;
    Label34: TLabel;
    cbGroupMaster: TComboBox;
    btGroupUpdateAll: TButton;
    chGroupAutoSwOn: TCheckBox;
    Label35: TLabel;
    cgGroupLineColor: TColorBox;
    btNone1: TrURLLabel;
    btNone2: TrURLLabel;
    btGroupCollapse: TButton;
    btGroupExpand: TButton;
    Label36: TLabel;
    eGroupMasterMask: TEdit;
    rHTMLLabel3: TrHTMLLabel;
    btGroupAddMask: TButton;
    rHTMLLabel2: TrHTMLLabel;
    chGroupLock: TCheckBox;
    procedure CheckListDblClick(Sender: TObject);
    procedure chEditGroupClick(Sender: TObject);
    procedure chEnaAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbColDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure btUpClick(Sender: TObject);
    procedure btDownClick(Sender: TObject);
    procedure lbColClickCheck(Sender: TObject);
    procedure lbColDblClick(Sender: TObject);
    procedure lbColKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btDelClick(Sender: TObject);
    procedure btDelAllClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btMoveClick(Sender: TObject);
    procedure btMoveAllClick(Sender: TObject);
    procedure lbColClick(Sender: TObject);
    procedure eTitleChange(Sender: TObject);
    procedure eTitleEnter(Sender: TObject);
    procedure eTitleExit(Sender: TObject);
    procedure btNextClick(Sender: TObject);
    procedure lbLinkDblClick(Sender: TObject);
    procedure lbBoolDblClick(Sender: TObject);
    procedure lbBoolClick(Sender: TObject);
    procedure lbBoolClickCheck(Sender: TObject);
    procedure eBoolValExit(Sender: TObject);
    procedure btDelNoFieldClick(Sender: TObject);
    procedure lbLinkClickCheck(Sender: TObject);
    procedure lbLinkClick(Sender: TObject);
    procedure lbTitleImgDblClick(Sender: TObject);
    procedure lbTitleImgClickCheck(Sender: TObject);
    procedure lbTitleImgClick(Sender: TObject);
    procedure eTitleImgExit(Sender: TObject);
    procedure cbLinkTypeExit(Sender: TObject);
    procedure eTitleImgChange(Sender: TObject);
    procedure cbDataImgChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbDataImgClick(Sender: TObject);
    procedure eDataImgValExit(Sender: TObject);
    procedure btDDelClick(Sender: TObject);
    procedure btDAddClick(Sender: TObject);
    procedure eDataImgIdxChange(Sender: TObject);
    procedure cbDataImgDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure UpDownTitleImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
    procedure UpDownDataImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
    procedure chReadOnlyClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lbPickClickCheck(Sender: TObject);
    procedure lbDrawPickClickCheck(Sender: TObject);
    procedure lbPickDblClick(Sender: TObject);
    procedure lbDrawPickDblClick(Sender: TObject);
    procedure lbHintsClick(Sender: TObject);
    procedure lbHintsClickCheck(Sender: TObject);
    procedure lbHintsDblClick(Sender: TObject);
    procedure eHintExit(Sender: TObject);
    procedure btCollapseClick(Sender: TObject);
    procedure lbGroupsClick(Sender: TObject);
    procedure btGroupUpdateClick(Sender: TObject);
    procedure btNewGroupClick(Sender: TObject);
    procedure btDelGroupClick(Sender: TObject);
    procedure lbGroupFieldsClickCheck(Sender: TObject);
    procedure cbGroupMasterChange(Sender: TObject);
    procedure btGroupUpdateAllClick(Sender: TObject);
    procedure pcChange(Sender: TObject);
    procedure lbColDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure cgGroupTitleColorExit(Sender: TObject);
    procedure eGroupTitleEnter(Sender: TObject);
    procedure eGroupTitleExit(Sender: TObject);
    procedure btGroupCollapseClick(Sender: TObject);
    procedure btGroupAddMaskClick(Sender: TObject);
    procedure lbGroupFieldsDblClick(Sender: TObject);
    procedure Label22GetParameter(Sender: TObject; var ParamStr: string);
  private
    { Private declarations }
    Gr: TrDBGrid;
    Tag: Integer;
    Cs: TDBGridColumns;
    Flds: TFields;
    FAsLink: TStrings;
    FAsPick: TStrings;
    FAsColor: TStrings;
    FAsBool: TStrings;
    FAsDate: TStrings;
    FAsGraphics: TStrings;
    FDrawDropDown: TStrings;
    FTitleHints: TStrings;
    FFilterBtn: TStrings;
    FTitleImgList: TImageList;
    FTitleImg: TStrings;
    FDataImgList: TImageList;
    FDataImg: TStrings;
    FDataImgIni: TMemIniFile;
    FFieldsGroups: TStrings;
    FFieldsGroupsIni: TMemIniFile;
    procedure LoadProps;
    procedure SetProps;
    procedure LoadCol(KeepSelected: Boolean);
    procedure AddCol(Fld: TField);
    procedure MoveI(List: TCheckListBox; old, new: Integer);
    procedure CheckI(act: Integer);
    procedure RefAll;
    procedure SetIniSection;
    procedure LoadDrawPick;
    procedure StoreDrawPick;
    procedure LoadGroups(KeepSelected: Boolean);
    procedure LoadGroupFields;
    function GetSelGroupName: string;
  public
    { Public declarations }
  end;

function ShowrDBGridEditor(Component: TComponent): Boolean;

implementation

{$R *.dfm}
uses TypInfo, RosiCompGlobalCfg, rtool, rdlg, rpictool;

const
  cTag = 'Tag';

function ShowrDBGridEditor(Component: TComponent): Boolean;
var
  F: TrDBGrid_DTEditForm;
  DS: TDataSource;
begin
  Result:=true;
  F:=TrDBGrid_DTEditForm.Create(Application);
  try
    F.Caption:=Component.Name;
    F.Gr:=(Component as TrDBGrid);
    F.Tag:=GetOrdProp(Component, cTag);
    F.Cs:=GetObjectProp(Component, 'Columns') as TDBGridColumns;
    F.FAsLink:=GetObjectProp(Component, 'FieldsAsLink') as TStrings;
    F.FAsPick:=GetObjectProp(Component, 'FieldsAutoPickList') as TStrings;
    F.FAsColor:=GetObjectProp(Component, 'FieldsAsColor') as TStrings;
    F.FAsBool:=GetObjectProp(Component, 'FieldsAsBoolean') as TStrings;

    F.FAsDate:=GetObjectProp(Component, 'FieldsAsDate') as TStrings;
    F.FAsGraphics:=GetObjectProp(Component, 'FieldsAsGraphics') as TStrings;
    F.FDrawDropDown:=GetObjectProp(Component, 'FieldsDrawDropDown') as TStrings;
    F.FTitleHints:=GetObjectProp(Component, 'TitleHints') as TStrings;
    F.FFilterBtn:=GetObjectProp(Component, 'FieldsFilterButton') as TStrings;

    F.FTitleImg:=GetObjectProp(Component, 'TitleImages') as TStrings;
    F.FTitleImgList:=GetObjectProp(Component, 'TitleImageList') as TImageList;
    F.FDataImg:=GetObjectProp(Component, 'DataImages') as TStrings;
    F.FDataImgList:=GetObjectProp(Component, 'DataImageList') as TImageList;

    F.FFieldsGroups:=GetObjectProp(Component, 'FieldsGroups') as TStrings;

    F.Flds:=nil;
    try
      DS:=GetObjectProp(Component, 'DataSource') as TDataSource;
      if Assigned(DS) and Assigned(DS.DataSet) then
        F.Flds:=DS.DataSet.Fields;
    except
    end;
    F.ShowModal;
    SetOrdProp(Component, cTag, F.Tag);

    F.Gr.FixedGroupedCol(false);
  finally
    F.Free;
  end;
  with (Component as TControl) do
    Invalidate;
end;

procedure TrDBGrid_DTEditForm.FormCreate(Sender: TObject);
begin
  FDataImgIni:=TMemIniFile.Create('');
  FFieldsGroupsIni:=TMemIniFile.Create('');
  PSFile.LoadFile(GetRosiCompIniFile);
  eDataImgVal.Items.Add(DataImagesFieldCfg);
end;

procedure TrDBGrid_DTEditForm.FormDestroy(Sender: TObject);
begin
  FDataImgIni.Free;
  FFieldsGroupsIni.Free;
end;

procedure TrDBGrid_DTEditForm.FormResize(Sender: TObject);
begin
  gbLeft1.Width:=pc.ClientWidth div 2;
  gbLeft2.Width:=pc.ClientWidth div 2;
  gbLeft3.Width:=pc.ClientWidth div 2;
  gbLeft4.Width:=pc.ClientWidth div 2;
  gbLeft5.Width:=pc.ClientWidth div 2;
  gbLeft6.Width:=pc.ClientWidth div 2;
  gbLeftGroups.Width:=pc.ClientWidth div 2 + 18;
end;

procedure TrDBGrid_DTEditForm.FormShow(Sender: TObject);
begin
  pc.ActivePageIndex:=0;
  LoadProps;
end;

procedure TrDBGrid_DTEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetProps;
end;

procedure TrDBGrid_DTEditForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TrDBGrid_DTEditForm.btCollapseClick(Sender: TObject);
var
  F: TField;
begin
  if lbCol.ItemIndex < 0 then
    Exit;
  if not lbCol.Checked[lbCol.ItemIndex] then
    Exit;

  F:=Cs[lbCol.ItemIndex].Field;
  if Sender = btCollapse then
    Gr.CollapseGroup(F)
  else
    Gr.ExpandGroup(F);
  LoadCol(true);
end;

procedure TrDBGrid_DTEditForm.LoadProps;
var
  i, p: Integer;
  s: string;
begin
  // set actions controls
  chEnaAll.Checked:=Tag <> -1;
  if chEnaAll.Checked then
  begin
    chEditGroup.Checked:=Tag and 1 = 0;
    chSort.Checked:=Tag and 2 = 0;
    chFilter.Checked:=Tag and 4 = 0;
    chColumn.Checked:=Tag and 8 = 0;
    chProps.Checked:=Tag and 16 = 0;
    chClose.Checked:=Tag and 128 = 0;

    chAdd.Checked:=Tag and 1024 = 0;
    chDuplic.Checked:=Tag and 256 = 0;
    chEdit.Checked:=Tag and 2048 = 0;
    chDelete.Checked:=Tag and 4096 = 0;
    chSaveAdd.Checked:=Tag and 512 = 0;
    chAutoEdit.Checked:=Tag and 8192 = 0;
  end;
  chEnaAllClick(nil);
  chEditGroupClick(nil);
  // load fields
  lbFields.Clear;
  if Flds <> nil then
    for i:=0 to Flds.Count - 1 do
      lbFields.Items.Add(Flds[i].FieldName);
  LoadCol(false);
  RefAll;

  // load FieldsAsLink
  lbLink.Items.Assign(lbFields.Items);
  for i:=0 to FAsLink.Count - 1 do
  begin
    // check and convert old format (without values)
    s:=Trim(FAsLink.Strings[i]);
    if (Length(s) > 0) and (Pos('=', s) = 0) then
      FAsLink.Strings[i]:=s + '=' + cbLinkType.Items[0];
    // set lbLink
    p:=lbLink.Items.IndexOf(FAsLink.Names[i]);
    if p >= 0 then
      lbLink.Checked[p]:=true;
  end;

  // load FieldAsBool list
  lbBool.Items.Assign(lbFields.Items);
  for i:=0 to FAsBool.Count - 1 do
  begin
    // check and convert old format (without values)
    s:=Trim(FAsBool.Strings[i]);
    if (Length(s) > 0) and (Pos('=', s) = 0) then
      FAsBool.Strings[i]:=s + '=' + DefBoolValue;
    // set lbBool
    p:=lbBool.Items.IndexOf(FAsBool.Names[i]);
    if p >= 0 then
      lbBool.Checked[p]:=true;
  end;

  // load AutoPickList
  lbPick.Items.Assign(lbFields.Items);
  for i:=0 to FAsPick.Count - 1 do
  begin
    p:=lbPick.Items.IndexOf(FAsPick.Strings[i]);
    if p >= 0 then
      lbPick.Checked[p]:=true;
  end;
  LoadDrawPick;

  // load ColorPickList
  lbColor.Items.Assign(lbFields.Items);
  for i:=0 to FAsColor.Count - 1 do
  begin
    p:=lbColor.Items.IndexOf(FAsColor.Strings[i]);
    if p >= 0 then
      lbColor.Checked[p]:=true;
  end;

  // load FieldAsDate
  lbDate.Items.Assign(lbFields.Items);
  for i:=0 to FAsDate.Count - 1 do
  begin
    p:=lbDate.Items.IndexOf(FAsDate.Strings[i]);
    if p >= 0 then
      lbDate.Checked[p]:=true;
  end;
  // load FieldAsGraphics
  lbGraphics.Items.Assign(lbFields.Items);
  for i:=0 to FAsGraphics.Count - 1 do
  begin
    p:=lbGraphics.Items.IndexOf(FAsGraphics.Strings[i]);
    if p >= 0 then
      lbGraphics.Checked[p]:=true;
  end;

  // load TitleImgList
  lbTitleImg.Items.Assign(lbFields.Items);
  for i:=0 to FTitleImg.Count - 1 do
  begin
    p:=lbTitleImg.Items.IndexOf(FTitleImg.Names[i]);
    if p >= 0 then
      lbTitleImg.Checked[p]:=true;
  end;

  // load DataImg
  cbDataImg.Items.Assign(lbFields.Items);
  FDataImgIni.SetStrings(FDataImg);

  FFieldsGroupsIni.SetStrings(FFieldsGroups);
  LoadGroups(false);

  // load TitleHints
  lbHints.Items.Assign(lbFields.Items);
  for i:=0 to FTitleHints.Count - 1 do
  begin
    p:=lbHints.Items.IndexOf(FTitleHints.Names[i]);
    if p >= 0 then
      lbHints.Checked[p]:=true;
  end;

  // load FilterButtons
  lbFilterFields.Items.Assign(lbFields.Items);
  for i:=0 to FFilterBtn.Count - 1 do
  begin
    p:=lbFilterFields.Items.IndexOf(FFilterBtn.Strings[i]);
    if p >= 0 then
      lbFilterFields.Checked[p]:=true;
  end;
end;

procedure TrDBGrid_DTEditForm.SetProps;
var
  i: Integer;
begin
  // set action control
  if not chEnaAll.Checked then
    Tag:=-1
  else
  begin
    Tag:=0;
    if not chEditGroup.Checked then
      Tag:=Tag or 1;
    if not chSort.Checked then
      Tag:=Tag or 2;
    if not chFilter.Checked then
      Tag:=Tag or 4;
    if not chColumn.Checked then
      Tag:=Tag or 8;
    if not chProps.Checked then
      Tag:=Tag or 16;
    if not chClose.Checked then
      Tag:=Tag or 128;

    if not chAdd.Checked then
      Tag:=Tag or 1024;
    if not chDuplic.Checked then
      Tag:=Tag or 256;
    if not chEdit.Checked then
      Tag:=Tag or 2048;
    if not chDelete.Checked then
      Tag:=Tag or 4096;
    if not chSaveAdd.Checked then
      Tag:=Tag or 512;
    if not chAutoEdit.Checked then
      Tag:=Tag or 8192;
  end;

  FAsPick.Clear;
  for i:=0 to lbPick.Items.Count - 1 do
    if lbPick.Checked[i] then
      FAsPick.Add(lbPick.Items[i]);

  FAsColor.Clear;
  for i:=0 to lbColor.Items.Count - 1 do
    if lbColor.Checked[i] then
      FAsColor.Add(lbColor.Items[i]);

  FAsDate.Clear;
  for i:=0 to lbDate.Items.Count - 1 do
    if lbDate.Checked[i] then
      FAsDate.Add(lbDate.Items[i]);

  FAsGraphics.Clear;
  for i:=0 to lbGraphics.Items.Count - 1 do
    if lbGraphics.Checked[i] then
      FAsGraphics.Add(lbGraphics.Items[i]);

  FFilterBtn.Clear;
  for i:=0 to lbFilterFields.Items.Count - 1 do
    if lbFilterFields.Checked[i] then
      FFilterBtn.Add(lbFilterFields.Items[i]);

  FDataImg.Clear;
  FDataImgIni.GetStrings(FDataImg);

  FFieldsGroups.Clear;
  FFieldsGroupsIni.GetStrings(FFieldsGroups);
end;

procedure TrDBGrid_DTEditForm.CheckListDblClick(Sender: TObject);
var
  lb: TCheckListBox;
begin
  lb:=Sender as TCheckListBox;
  lb.Checked[lb.ItemIndex]:=not lb.Checked[lb.ItemIndex];
end;

// COLUMNS proc
procedure TrDBGrid_DTEditForm.LoadCol(KeepSelected: Boolean);
var
  i, oldId, oldTop: Integer;
begin
  // load columns
  oldId:=lbCol.ItemIndex;
  oldTop:=lbCol.TopIndex;
  lbCol.Items.BeginUpdate;
  try
    lbCol.Items.Clear;
    for i:=0 to Cs.Count - 1 do
      lbCol.Items.Add(Cs[i].Title.Caption);
    for i:=0 to Cs.Count - 1 do
    begin
      lbCol.Checked[i]:=Cs[i].Visible;
      with Gr.GetFieldGroupInfo(Cs[i].Field) do
        if IsGrouped and not IsMaster then
          lbCol.ItemEnabled[i]:=Gr.IsFieldGroupMasterVisible(Cs[i].Field);
    end;
    if KeepSelected then
    begin
      lbCol.TopIndex:=oldTop;
      if (oldId >= 0) and (oldId < lbCol.Items.Count) then
        lbCol.ItemIndex:=oldId;
      RefAll;
    end;
  finally
    lbCol.Items.EndUpdate;
  end;
  lbCol.Invalidate;
end;

procedure TrDBGrid_DTEditForm.AddCol(Fld: TField);
var
  C: TColumn;
  oldItemIndex: Integer;
begin
  oldItemIndex:=lbCol.ItemIndex;
  C:=Cs.Add;
  C.FieldName:=Fld.FieldName;
  C.Title.Caption:=ReplaceStr(eSep.Text, ' ', Fld.DisplayLabel, true, false);
  C.Title.Alignment:=C.Alignment;
  C.ReadOnly:=Fld.ReadOnly;
  C.Visible:=Fld.Visible;
  try
    if Assigned(Fld) then
      C.Width:=Fld.DisplayWidth * 4;
    if C.Width < 50 then
      C.Width:=50;
    if C.Width > 200 then
      C.Width:=200;
  except
  end;
  if (oldItemIndex < 0) or (oldItemIndex > Cs.Count - 1) then
    oldItemIndex:=Cs.Count - 1
  else
    Inc(oldItemIndex);
  C.Index:=oldItemIndex;
  LoadCol(false);
  lbCol.ItemIndex:=oldItemIndex;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.MoveI(List: TCheckListBox; old, new: Integer);
begin
  if not MoveCheckListBox(List, old, new) then
    Exit;
  Cs[old].Index:=new;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.pcChange(Sender: TObject);
begin
  if pc.ActivePage = tsGroup then
    LoadGroups(true);
end;

procedure TrDBGrid_DTEditForm.CheckI(act: Integer);
begin
  if not lbCol.ItemEnabled[act] then
    Exit;
  Cs[act].Visible:=lbCol.Checked[act];
  if Gr.GetFieldGroupInfo(Cs[act].Field).IsMaster then
  begin
    if (not Cs[act].Visible) then
      Gr.CollapseGroup(Cs[act].Field);
    LoadCol(true);
  end;
end;

procedure TrDBGrid_DTEditForm.RefAll;
begin
  gbColBottom.Enabled:=(lbCol.ItemIndex >= 0) and (lbCol.ItemIndex < Cs.Count) and (lbCol.ItemIndex < lbCol.Count);
  if gbColBottom.Enabled then
  begin
    lblFName.Caption:=Cs[lbCol.ItemIndex].FieldName;
    eTitle.Text:=lbCol.Items[lbCol.ItemIndex];
    chReadOnly.Checked:=Cs[lbCol.ItemIndex].ReadOnly;
    chReadOnly.Enabled:=true;
  end
  else
  begin
    lblFName.Caption:='';
    eTitle.Text:='';
  end;
  btUp.Enabled:=gbColBottom.Enabled;
  btDown.Enabled:=gbColBottom.Enabled;
  btCollapse.Enabled:=gbColBottom.Enabled and Gr.GetFieldGroupInfo(Cs[lbCol.ItemIndex].Field).IsMaster;
  btExpand.Enabled:=gbColBottom.Enabled and btCollapse.Enabled;
end;

procedure TrDBGrid_DTEditForm.lbColDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=true;
  MoveI(lbCol, lbCol.ItemIndex, Y div lbCol.ItemHeight + lbCol.TopIndex);
end;

procedure TrDBGrid_DTEditForm.lbColDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with Control as TCheckListBox do
  begin
    Canvas.FillRect(Rect);
    if Gr.GetFieldGroupInfo(Cs[Index].Field).IsMaster then
      Canvas.Font.Style:=Canvas.Font.Style + [fsBold];
    Canvas.TextOut(Rect.Left + 1, Rect.Top, Items[Index]);
  end;
end;

procedure TrDBGrid_DTEditForm.btUpClick(Sender: TObject);
begin
  MoveI(lbCol, lbCol.ItemIndex, lbCol.ItemIndex - 1);
end;

procedure TrDBGrid_DTEditForm.btDownClick(Sender: TObject);
begin
  MoveI(lbCol, lbCol.ItemIndex, lbCol.ItemIndex + 1);
end;

procedure TrDBGrid_DTEditForm.lbColClickCheck(Sender: TObject);
begin
  CheckI(lbCol.ItemIndex);
end;

procedure TrDBGrid_DTEditForm.lbColDblClick(Sender: TObject);
begin
  if not lbCol.ItemEnabled[lbCol.ItemIndex] then
    Exit;
  lbCol.Checked[lbCol.ItemIndex]:=not lbCol.Checked[lbCol.ItemIndex];
  CheckI(lbCol.ItemIndex);
end;

procedure TrDBGrid_DTEditForm.lbColKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) and (ssCtrl in Shift) then
  begin
    MoveI(lbCol, lbCol.ItemIndex, lbCol.ItemIndex - 1);
    Key:=0;
  end;
  if (Key = VK_DOWN) and (ssCtrl in Shift) then
  begin
    MoveI(lbCol, lbCol.ItemIndex, lbCol.ItemIndex + 1);
    Key:=0;
  end;
  if (Key = VK_DELETE) then
  begin
    btDel.Click;
    Key:=0;
  end;
end;

procedure TrDBGrid_DTEditForm.btDelClick(Sender: TObject);
var
  i: Integer;
begin
  i:=lbCol.ItemIndex;
  if i = -1 then
    Exit;
  Cs.Delete(i);
  lbCol.Items.Delete(i);
  if i > lbCol.Items.Count - 1 then
    i:=lbCol.Items.Count - 1;
  lbCol.ItemIndex:=i;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.btDelAllClick(Sender: TObject);
begin
  if DlgQ('Delete all columns?') <> mrYes then
    Exit;
  Cs.Clear;
  lbCol.Clear;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.btDelNoFieldClick(Sender: TObject);
var
  i: Integer;
begin
  if DlgQ('Delete all orphan columns (without field)?') <> mrYes then
    Exit;
  for i:=Cs.Count - 1 downto 0 do
    if lbFields.Items.IndexOf(Cs.Items[i].FieldName) < 0 then
    begin
      Cs.Delete(i);
      lbCol.Items.Delete(i);
    end;
  RefAll;
end;

procedure TrDBGrid_DTEditForm.chEditGroupClick(Sender: TObject);
begin
  gbEdit.Visible:=chEditGroup.Checked;
end;

procedure TrDBGrid_DTEditForm.chEnaAllClick(Sender: TObject);
begin
  gbActions.Visible:=chEnaAll.Checked;
end;

procedure TrDBGrid_DTEditForm.btMoveClick(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to lbFields.Items.Count - 1 do
    if lbFields.Selected[i] then
      AddCol(Flds[i]);
  // LoadProps;
end;

procedure TrDBGrid_DTEditForm.btMoveAllClick(Sender: TObject);
var
  i: Integer;
begin
  if DlgQ('Add all columns?') <> mrYes then
    Exit;
  for i:=0 to lbFields.Items.Count - 1 do
    lbFields.Selected[i]:=true;
  btMove.Click;
end;

procedure TrDBGrid_DTEditForm.lbColClick(Sender: TObject);
begin
  RefAll;
end;

procedure TrDBGrid_DTEditForm.eTitleChange(Sender: TObject);
begin
  if not eTitle.Focused then
    Exit;
  lbCol.Items[lbCol.ItemIndex]:=eTitle.Text;
  Cs[lbCol.ItemIndex].Title.Caption:=eTitle.Text;
end;

procedure TrDBGrid_DTEditForm.chReadOnlyClick(Sender: TObject);
begin
  if not chReadOnly.Focused then
    Exit;
  Cs[lbCol.ItemIndex].ReadOnly:=chReadOnly.Checked;
end;

procedure TrDBGrid_DTEditForm.eTitleEnter(Sender: TObject);
begin
  btNext.Default:=true;
end;

procedure TrDBGrid_DTEditForm.eTitleExit(Sender: TObject);
begin
  btNext.Default:=false;
end;

procedure TrDBGrid_DTEditForm.btNextClick(Sender: TObject);
begin
  if lbCol.ItemIndex < lbCol.Items.Count - 1 then
    lbCol.ItemIndex:=lbCol.ItemIndex + 1;
  lbColClick(nil);
end;

// LINK proc
procedure TrDBGrid_DTEditForm.lbLinkDblClick(Sender: TObject);
begin
  CheckListDblClick(Sender);
  lbLinkClickCheck(Sender);
  lbLinkClick(Sender);
end;

procedure TrDBGrid_DTEditForm.lbLinkClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbLink.Checked[lbLink.ItemIndex] then
  begin
    i:=FAsLink.IndexOfName(lbLink.Items[lbLink.ItemIndex]);
    if i >= 0 then
      FAsLink.Delete(i);
  end
  else
  begin
    FAsLink.Add(lbLink.Items[lbLink.ItemIndex] + '=' + cbLinkType.Items[0]);
  end;
end;

procedure TrDBGrid_DTEditForm.lbLinkClick(Sender: TObject);
begin
  cbLinkType.ItemIndex:=-1;
  cbLinkType.Enabled:=lbLink.Checked[lbLink.ItemIndex];
  if cbLinkType.Enabled then
    cbLinkType.ItemIndex:=cbLinkType.Items.IndexOf(FAsLink.Values[lbLink.Items[lbLink.ItemIndex]]);
end;

procedure TrDBGrid_DTEditForm.cbLinkTypeExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FAsLink.IndexOfName(lbLink.Items[lbLink.ItemIndex]);
  if i >= 0 then
    FAsLink.Values[lbLink.Items[lbLink.ItemIndex]]:=cbLinkType.Text;
end;

// PICKLIST proc
procedure TrDBGrid_DTEditForm.lbPickClickCheck(Sender: TObject);
begin
  LoadDrawPick;
end;

procedure TrDBGrid_DTEditForm.lbPickDblClick(Sender: TObject);
begin
  CheckListDblClick(Sender);
  lbPickClickCheck(Sender);
end;

procedure TrDBGrid_DTEditForm.LoadDrawPick;
var
  i: Integer;
begin
  lbDrawPick.Items.Clear;
  for i:=0 to lbPick.Items.Count - 1 do
    if lbPick.Checked[i] then
      lbDrawPick.Items.Add(lbPick.Items[i]);
  for i:=0 to lbDrawPick.Items.Count - 1 do
    lbDrawPick.Checked[i]:=FDrawDropDown.IndexOf(lbDrawPick.Items[i]) >= 0;
end;

procedure TrDBGrid_DTEditForm.StoreDrawPick;
var
  i: Integer;
begin
  FDrawDropDown.Clear;
  for i:=0 to lbDrawPick.Items.Count - 1 do
    if lbDrawPick.Checked[i] then
      FDrawDropDown.Add(lbDrawPick.Items[i]);
end;

// BOOLFIELDS proc
procedure TrDBGrid_DTEditForm.lbBoolDblClick(Sender: TObject);
begin
  CheckListDblClick(Sender);
  lbBoolClickCheck(Sender);
  lbBoolClick(Sender);
end;

procedure TrDBGrid_DTEditForm.lbBoolClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbBool.Checked[lbBool.ItemIndex] then
  begin
    i:=FAsBool.IndexOfName(lbBool.Items[lbBool.ItemIndex]);
    if i >= 0 then
      FAsBool.Delete(i);
  end
  else
  begin
    FAsBool.Add(lbBool.Items[lbBool.ItemIndex] + '=' + DefBoolValue);
  end;
end;

procedure TrDBGrid_DTEditForm.lbBoolClick(Sender: TObject);
begin
  eBoolVal.Text:='';
  eBoolVal.Enabled:=lbBool.Checked[lbBool.ItemIndex];
  if eBoolVal.Enabled then
    eBoolVal.Text:=FAsBool.Values[lbBool.Items[lbBool.ItemIndex]];
end;

procedure TrDBGrid_DTEditForm.eBoolValExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FAsBool.IndexOfName(lbBool.Items[lbBool.ItemIndex]);
  if i >= 0 then
    FAsBool.Values[lbBool.Items[lbBool.ItemIndex]]:=eBoolVal.Text;
end;

// TITLEIMAGE proc
procedure TrDBGrid_DTEditForm.lbTitleImgDblClick(Sender: TObject);
begin
  CheckListDblClick(Sender);
  lbTitleImgClickCheck(Sender);
  lbTitleImgClick(Sender);
end;

procedure TrDBGrid_DTEditForm.lbTitleImgClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if not lbTitleImg.Checked[lbTitleImg.ItemIndex] then
  begin
    i:=FTitleImg.IndexOfName(lbTitleImg.Items[lbTitleImg.ItemIndex]);
    if i >= 0 then
      FTitleImg.Delete(i);
  end
  else
  begin
    FTitleImg.Add(lbTitleImg.Items[lbTitleImg.ItemIndex] + '=0');
  end;
end;

procedure TrDBGrid_DTEditForm.lbHintsClick(Sender: TObject);
begin
  eHint.Text:='';
  eHint.Enabled:=lbHints.Checked[lbHints.ItemIndex];
  if eHint.Enabled then
    eHint.Text:=FTitleHints.Values[lbHints.Items[lbHints.ItemIndex]];
end;

procedure TrDBGrid_DTEditForm.lbHintsClickCheck(Sender: TObject);
var
  i: Integer;
  s: string;
begin
  s:=lbHints.Items[lbHints.ItemIndex];
  if not lbHints.Checked[lbHints.ItemIndex] then
  begin
    i:=FTitleHints.IndexOfName(s);
    if i >= 0 then
      FTitleHints.Delete(i);
  end
  else
  begin
    FTitleHints.Add(s + '=' + s);
  end;
end;

procedure TrDBGrid_DTEditForm.lbHintsDblClick(Sender: TObject);
begin
  CheckListDblClick(Sender);
  lbHintsClickCheck(Sender);
  lbHintsClick(Sender);
end;

procedure TrDBGrid_DTEditForm.eHintExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FTitleHints.IndexOfName(lbHints.Items[lbHints.ItemIndex]);
  if i >= 0 then
    FTitleHints.Values[lbHints.Items[lbHints.ItemIndex]]:=eHint.Text;
end;

procedure TrDBGrid_DTEditForm.lbTitleImgClick(Sender: TObject);
begin
  eTitleImg.AsInteger:=-1;
  eTitleImg.Enabled:=lbTitleImg.Checked[lbTitleImg.ItemIndex];
  UpDownTitleImg.Enabled:=eTitleImg.Enabled;
  if eTitleImg.Enabled then
    eTitleImg.Text:=FTitleImg.Values[lbTitleImg.Items[lbTitleImg.ItemIndex]];
end;

procedure TrDBGrid_DTEditForm.eTitleImgExit(Sender: TObject);
var
  i: Integer;
begin
  i:=FTitleImg.IndexOfName(lbTitleImg.Items[lbTitleImg.ItemIndex]);
  if i >= 0 then
    FTitleImg.Values[lbTitleImg.Items[lbTitleImg.ItemIndex]]:=eTitleImg.Text;
end;

procedure TrDBGrid_DTEditForm.eTitleImgChange(Sender: TObject);
begin
  TitleImg.Picture.Bitmap:=nil;
  // UpDownTitleImg.Position:=eTitleImg.AsInteger;
  if Assigned(FTitleImgList) and (eTitleImg.AsInteger >= 0) and (eTitleImg.AsInteger < FTitleImgList.Count) then
  begin
    FTitleImgList.GetBitmap(eTitleImg.AsInteger, TitleImg.Picture.Bitmap);
  end;
end;

// DataImage proc
procedure TrDBGrid_DTEditForm.SetIniSection;
var
  i: Integer;
begin
  FDataImgIni.EraseSection(cbDataImg.Text);
  for i:=0 to lbDataImg.Items.Count - 1 do
    FDataImgIni.WriteString(cbDataImg.Text, lbDataImg.Items.Names[i], lbDataImg.Items.Values[lbDataImg.Items.Names[i]]);
end;

procedure TrDBGrid_DTEditForm.cbDataImgChange(Sender: TObject);
begin
  lbDataImg.Items.Clear;
  FDataImgIni.ReadSectionValues(cbDataImg.Text, lbDataImg.Items);
  lbDataImgClick(Self);
end;

procedure TrDBGrid_DTEditForm.lbDataImgClick(Sender: TObject);
var
  s: string;
begin
  eDataImgVal.Text:='';
  eDataImgText.Text:='';
  eDataImgIdx.AsInteger:=-1;
  eDataImgVal.Enabled:=lbDataImg.ItemIndex >= 0;
  eDataImgText.Enabled:=eDataImgVal.Enabled;
  eDataImgIdx.Enabled:=eDataImgVal.Enabled;
  UpDownDataImg.Enabled:=eDataImgVal.Enabled;
  if lbDataImg.ItemIndex < 0 then
    Exit;
  eDataImgVal.Text:=lbDataImg.Items.Names[lbDataImg.ItemIndex];
  s:=lbDataImg.Items.Values[eDataImgVal.Text];
  try
    StrToInt(s);
    eDataImgIdx.Text:=s;
  except
    eDataImgText.Text:=s;
    eDataImgIdx.Enabled:=false;
    UpDownDataImg.Enabled:=false;
  end;
end;

procedure TrDBGrid_DTEditForm.lbDrawPickClickCheck(Sender: TObject);
begin
  StoreDrawPick;
end;

procedure TrDBGrid_DTEditForm.lbDrawPickDblClick(Sender: TObject);
begin
  CheckListDblClick(Sender);
  lbDrawPickClickCheck(Sender);
end;

procedure TrDBGrid_DTEditForm.eDataImgValExit(Sender: TObject);
var
  s: string;
begin
  if lbDataImg.ItemIndex < 0 then
    Exit;
  if eDataImgVal.Text = '' then
  begin
    eDataImgVal.SetFocus;
    Exit;
  end;
  s:=eDataImgText.Text;
  eDataImgIdx.Enabled:=s = '';
  UpDownDataImg.Enabled:=s = '';
  if s = '' then
    s:=eDataImgIdx.Text;
  lbDataImg.Items[lbDataImg.ItemIndex]:=eDataImgVal.Text + '=' + s;
  lbDataImgClick(Self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.btDDelClick(Sender: TObject);
begin
  if lbDataImg.ItemIndex < 0 then
    Exit;
  lbDataImg.Items.Delete(lbDataImg.ItemIndex);
  lbDataImgClick(Self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.btDAddClick(Sender: TObject);
begin
  lbDataImg.Items.Add('*=0');
  lbDataImg.ItemIndex:=lbDataImg.Items.Count - 1;
  lbDataImgClick(Self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.eDataImgIdxChange(Sender: TObject);
begin
  DataImg.Picture.Bitmap:=nil;
  // UpDownDataImg.Position:=eDataImgIdx.AsInteger;
  if Assigned(FDataImgList) and (eDataImgIdx.AsInteger >= 0) and (eDataImgIdx.AsInteger < FDataImgList.Count) then
  begin
    FDataImgList.GetBitmap(eDataImgIdx.AsInteger, DataImg.Picture.Bitmap);
  end;
end;

procedure TrDBGrid_DTEditForm.cbDataImgDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with Control as TComboBox do
  begin
    Canvas.FillRect(Rect);
    if FDataImgIni.SectionExists(Items[Index]) then
      Canvas.Font.Style:=Canvas.Font.Style + [fsBold];
    Canvas.TextOut(Rect.Left + 1, Rect.Top + 1, Items[Index]);
  end;
end;

procedure TrDBGrid_DTEditForm.UpDownTitleImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin
  if Direction = updUp then
    eTitleImg.AsInteger:=eTitleImg.AsInteger + 1;
  if Direction = updDown then
    eTitleImg.AsInteger:=eTitleImg.AsInteger - 1;
  eTitleImg.SetFocus;
end;

procedure TrDBGrid_DTEditForm.UpDownDataImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin
  if Direction = updUp then
    eDataImgIdx.AsInteger:=eDataImgIdx.AsInteger + 1;
  if Direction = updDown then
    eDataImgIdx.AsInteger:=eDataImgIdx.AsInteger - 1;
  eDataImgIdx.SetFocus;
end;

// GROUPFields proc
procedure TrDBGrid_DTEditForm.eGroupTitleEnter(Sender: TObject);
begin
  btGroupUpdateAll.Default:=true;
end;

procedure TrDBGrid_DTEditForm.eGroupTitleExit(Sender: TObject);
begin
  btGroupUpdateAll.Default:=false;
  btGroupUpdateClick(Sender);
end;

procedure TrDBGrid_DTEditForm.cgGroupTitleColorExit(Sender: TObject);
begin
  btGroupUpdateAll.Default:=false;
  btGroupUpdateClick(nil);
end;

procedure TrDBGrid_DTEditForm.LoadGroups(KeepSelected: Boolean);
var
  i: Integer;
begin
  i:=lbGroups.ItemIndex;
  FFieldsGroupsIni.ReadSections(lbGroups.Items);
  lbGroups.ItemIndex:=-1;
  if KeepSelected and (i >= 0) and (i < lbGroups.Items.Count) then
    lbGroups.ItemIndex:=i;
  lbGroupsClick(nil);
end;

function TrDBGrid_DTEditForm.GetSelGroupName: string;
begin
  if lbGroups.ItemIndex >= 0 then
    Result:=lbGroups.Items[lbGroups.ItemIndex]
  else
    Result:='';
end;

procedure TrDBGrid_DTEditForm.Label22GetParameter(Sender: TObject;
  var ParamStr: string);
begin
  ParamStr:=DataImagesFieldCfg;
end;

procedure TrDBGrid_DTEditForm.LoadGroupFields;
var
  i: Integer;
  L: TStringList;
  s: string;
begin
  L:=TStringList.Create;
  try
    FFieldsGroupsIni.ReadSectionValues(GetSelGroupName, L);
    // load group columns list and reset state
    lbGroupFields.Items.Assign(lbCol.Items);
    lbGroupFields.CheckAll(cbUnchecked);
    cbGroupMaster.Items.Clear;
    // remove non existing fields from Group definition
    for i:=0 to L.Count - 1 do
    begin
      if lbFields.Items.IndexOf(L.Names[i]) < 0 then
        FFieldsGroupsIni.DeleteKey(GetSelGroupName, L.Names[i]);
    end;
    // check grouped fields
    for i:=0 to Cs.Count - 1 do
    begin
      s:=L.Values[Cs[i].FieldName];
      if s <> '' then
      begin
        lbGroupFields.Checked[i]:=true;
        cbGroupMaster.Items.Add(lbGroupFields.Items[i]);
        if SameText(copy(s, 1, 1), 'M') then
          cbGroupMaster.ItemIndex:=cbGroupMaster.Items.IndexOf(lbGroupFields.Items[i]);
      end;
    end;
  finally
    L.Free;
  end;
end;

procedure TrDBGrid_DTEditForm.lbGroupFieldsClickCheck(Sender: TObject);
var
  i, idx: Integer;
  s: string;
begin
  i:=lbGroupFields.ItemIndex;
  if lbGroupFields.Checked[i] then
  begin
    // add grouped field
    if cbGroupMaster.Items.Count = 0 then
      // first field as Master
      s:='M'
    else
      s:='0';
    FFieldsGroupsIni.WriteString(GetSelGroupName, Cs[i].FieldName, s);
    cbGroupMaster.Items.Add(lbGroupFields.Items[i]);
    if cbGroupMaster.Items.Count = 1 then
      cbGroupMaster.ItemIndex:=0;
  end
  else
  begin
    // remove grouped field
    FFieldsGroupsIni.DeleteKey(GetSelGroupName, Cs[i].FieldName);
    idx:=cbGroupMaster.Items.IndexOf(lbGroupFields.Items[i]);
    if idx >= 0 then
      cbGroupMaster.Items.Delete(idx);
  end;
end;

procedure TrDBGrid_DTEditForm.lbGroupFieldsDblClick(Sender: TObject);
begin
  lbGroupFields.Checked[lbGroupFields.ItemIndex]:=not lbGroupFields.Checked[lbGroupFields.ItemIndex];
  lbGroupFieldsClickCheck(nil);
end;

procedure TrDBGrid_DTEditForm.cbGroupMasterChange(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to lbGroupFields.Items.Count - 1 do
  begin
    if lbGroupFields.Checked[i] then
      FFieldsGroupsIni.WriteString(GetSelGroupName, Cs[i].FieldName, '0');
  end;
  i:=lbGroupFields.Items.IndexOf(cbGroupMaster.Items[cbGroupMaster.ItemIndex]);
  if i >= 0 then
    FFieldsGroupsIni.WriteString(GetSelGroupName, Cs[i].FieldName, 'M');
end;

procedure TrDBGrid_DTEditForm.lbGroupsClick(Sender: TObject);
var
  sec, C: string;
begin
  gbGroupBottom.Enabled:=lbGroups.ItemIndex >= 0;
  gbRightGroups.Enabled:=gbGroupBottom.Enabled;
  if gbGroupBottom.Enabled then
  begin
    // read and decode group info from section name
    sec:=GetSelGroupName;
    // remove GroupID
    rtool.RemoveStrPart(sec, GroupHeaderSep, true);
    eGroupTitle.Text:=rtool.RemoveStrPart(sec, GroupHeaderSep, true);
    C:=rtool.RemoveStrPart(sec, GroupHeaderSep, true);
    cgGroupTitleColor.Selected:=rpictool.StringToColor(C);
    if C = '' then
      btNone1.Tag:=0
    else
      btNone1.Tag:=1;

    C:=rtool.RemoveStrPart(sec, GroupHeaderSep, true);
    cgGroupLineColor.Selected:=rpictool.StringToColor(C);
    if C = '' then
      btNone2.Tag:=0
    else
      btNone2.Tag:=1;

    eGroupMasterMask.Text:=rtool.RemoveStrPart(sec, GroupHeaderSep, true);
    C:=rtool.RemoveStrPart(sec, GroupHeaderSep, true);
    chGroupLock.Checked:=C = '1';

    LoadGroupFields;
  end
  else
  begin
    eGroupTitle.Text:='';
    cgGroupTitleColor.Selected:=clNone;
    cgGroupLineColor.Selected:=clNone;
    lbGroupFields.CheckAll(cbUnchecked);
  end;
  btDelGroup.Enabled:=gbGroupBottom.Enabled;
  btGroupCollapse.Enabled:=gbGroupBottom.Enabled;
  btGroupExpand.Enabled:=gbGroupBottom.Enabled;
end;

procedure TrDBGrid_DTEditForm.btGroupUpdateClick(Sender: TObject);
var
  sec, newsec, C: string;
  L: TStringList;
  i: Integer;
begin
  if Sender = cgGroupTitleColor then
    btNone1.Tag:=1;
  if Sender = cgGroupLineColor then
    btNone2.Tag:=1;

  if Sender = btNone1 then
  begin
    cgGroupTitleColor.Selected:=clNone;
    btNone1.Tag:=0;
  end;
  if Sender = btNone2 then
  begin
    cgGroupLineColor.Selected:=clNone;
    btNone2.Tag:=0;
  end;

  L:=TStringList.Create;
  try
    // use group id
    sec:=GetSelGroupName;
    newsec:=rtool.FindStrPart(sec, GroupHeaderSep, 1, true) + GroupHeaderSep;
    // code all other props to new section name
    newsec:=newsec + ReplaceStr(GroupHeaderSep, ': :', eGroupTitle.Text, true, true) + GroupHeaderSep;
    if btNone1.Tag = 0 then
      C:=''
    else
      C:=rpictool.ColorToString(cgGroupTitleColor.Selected, false);
    newsec:=newsec + C + GroupHeaderSep;
    if btNone2.Tag = 0 then
      C:=''
    else
      C:=rpictool.ColorToString(cgGroupLineColor.Selected, false);
    newsec:=newsec + C + GroupHeaderSep;
    newsec:=newsec + ReplaceStr(GroupHeaderSep, ': :', eGroupMasterMask.Text, true, true) + GroupHeaderSep;

    if chGroupLock.Checked then
      C:='1'
    else
      C:='0';
    newsec:=newsec + C;

    // update section name
    FFieldsGroupsIni.GetStrings(L);
    i:=L.IndexOf('[' + sec + ']');
    if i >= 0 then
      L[i]:='[' + newsec + ']';
    FFieldsGroupsIni.SetStrings(L);
    LoadGroups(true);
  finally
    L.Free;
  end;
end;

procedure TrDBGrid_DTEditForm.btNewGroupClick(Sender: TObject);
var
  ns: string;
  i, id, max: Integer;
begin
  // find max used id
  max:=0;
  for i:=0 to lbGroups.Items.Count - 1 do
  begin
    id:=StrToIntDef(rtool.FindStrPart(lbGroups.Items[i], GroupHeaderSep, 1, true), -1);
    if id > max then
      max:=id;
  end;
  // generate new group
  ns:=IntToStr(max + 1) + GroupHeaderSep + GroupHeaderSep + GroupHeaderSep;
  // create section by temp value
  FFieldsGroupsIni.WriteString(ns, '_temp_', '0');
  FFieldsGroupsIni.DeleteKey(ns, '_temp_');
  LoadGroups(false);
end;

procedure TrDBGrid_DTEditForm.btDelGroupClick(Sender: TObject);
begin
  if lbGroups.ItemIndex >= 0 then
  begin
    FFieldsGroupsIni.EraseSection(GetSelGroupName);
    LoadGroups(false);
    btGroupUpdateAll.Click;
  end;
end;

procedure TrDBGrid_DTEditForm.btGroupAddMaskClick(Sender: TObject);
begin
  if lbGroupFields.ItemIndex >= 0 then
  begin
    eGroupMasterMask.Text:=eGroupMasterMask.Text + '<<' + Cs[lbGroupFields.ItemIndex].FieldName + '>>';
    btGroupUpdateClick(nil);
  end;
end;

procedure TrDBGrid_DTEditForm.btGroupCollapseClick(Sender: TObject);
var
  id: Integer;
begin
  id:=StrToIntDef(rtool.FindStrPart(GetSelGroupName, GroupHeaderSep, 1, true), -1);
  if Sender = btGroupCollapse then
    Gr.CollapseGroup(id)
  else
    Gr.ExpandGroup(id);
  LoadCol(true);
end;

procedure TrDBGrid_DTEditForm.btGroupUpdateAllClick(Sender: TObject);
begin
  if btGroupUpdate.Enabled then
    btGroupUpdate.Click;
  FFieldsGroups.Clear;
  FFieldsGroupsIni.GetStrings(FFieldsGroups);
  Gr.FixedGroupedCol(chGroupAutoSwOn.Checked and (lbGroups.Items.Count > 0));
  LoadCol(false);
  lbGroupsClick(nil);
end;

end.
