unit rstring;

{<
  rstring is unit containing all resource strings.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Apr 2006)
  @lastmod(Lun 2015)
}

interface

const LangVer='EN';
const LangVerEN=1;

resourcestring

  // ***************************************************
  // COMMON STRING

  // Actions
  { }
  sInitialize = 'Initializing';
  sBrowsing = 'Browsing';
  sEditing = 'Editing';
  sInserting = 'Inserting';
  sLoading = 'Loading';
  sCreating = 'Creating';
  sPrinting = 'Printing';
  sExporting = 'Exporting';
  sLookingFor = 'Searching...';
  sWaiting = 'Waiting';
  sChecking = 'Checking';
  sImporting = 'Importing';
  sOfData = ' of data...';

  // Questions
  { }
  sContinueQ = 'Continue?';
  sTerminateQ = 'Terminate?';
  sCancelQ = 'Cancel?';
  sDeleteQ = 'Delete?';
  sOverwriteQ = 'Overwrite?';
  sTryAgainQ = 'Try again?';
  sSetDefaultValues = 'Reset to default properties?';
  sSaveChangesQ = 'Save changes?';
  sUseChangesQ = 'Use changes?';
  sUseFilterQ = 'Use selected filter?';

  // File and dir
  { }
  sFile = 'File "%s".';
  sFileNotFound = 'File "%s" not found.';
  sDirNotFound = 'Directory "%s" not found.';
  sFileExist = 'File "%s" already exists.';
  sDirExist = 'Directory "%s" already exists.';
  sFileSaved = 'File "%s" was saved.';
  sFileOpenQ = 'Open file "%s"?';
  sOpenOtherFileQ = 'Open another file?';
  sOpenLastFileQ = 'Open original file?';

  // File error
  { }
  sMakeDirErr = 'Cannot create targer directory "%s".';
  sFilePrintErr = 'Cannot print file "%s".';
  sFileOpenErr = 'Cannot open file "%s".';
  sFileOpenErr2 = 'File not exist (probably).';
  sFileSaveErr = 'Error during saving file "%s".';
  sFileSaveErr2 = 'You do not have access rights, target directory' + ' does not exist or target file is already opened in other application.';
  sDLLNotFound = 'Dynamic library "%s" not found or corrupted.';

  // File types
  { }
  sFileTypeAll = 'All files (*.*)|*.*';
  sFileTypeTXT = 'Text file (*.txt)|*.txt';
  sFileTypeSLK = 'Symbolic connection file (*.slk)|*.slk';
  sFileTypeRTF = 'Rich text format (*.rtf)|*.rtf';
  sFileTypeDOC = 'MSWord document (*.doc)|*.doc';
  sFileTypeDOCX = 'MSWord document (*.docx)|*.docx';
  sFileTypeODT = 'Open document format (*.odt)|*.odt';
  sFileTypeXLS = 'Excel file (*.xls)|*.xls';
  sFileTypeMDB = 'Database MS Access (*.mdb)|*.mdb';
  sFileTypeSQL = 'SQL command (*.sql)|*.sql';
  sFileTypeDBF = 'dBase file (*.dbf)|*.dbf';
  sFileTypePDF = 'PDF file (*.pdf)|*.pdf';
  sFileTypeBMP = 'Bitmaps (*.bmp)|*.bmp';
  sFileTypeJPG = 'Jpeg files (*.jpg;*.jpeg)|*.jpg;*.jpeg';
  sFileTypePNG = 'PNG files (*.png)|*.png';
  sFileTypeBMPJPG = 'Graphics formats (*.bmp;*.jpg;*.jpeg)|*.bmp;*.jpg;*.jpeg';
  sFileTypeBMPJPGPNG = 'Graphics formats (*.bmp;*.jpg;*.jpeg;*.png)|*.bmp;*.jpg;*.jpeg;*.png';

  // Error descriptions
  { }
  sErrorDescription = 'Error description:';
  sRuntimeErr = 'Runtime error.';
  sRaiseErr = 'Unexpected error. Close application and run again.';


  // Format error
  { }
  sInputErr = 'Error in input parameters.';
  sFormatNumberErr = 'Bad number format.';
  sFormatDateErr = 'Bad date format.';
  sFormatYearErr = 'Bad year format.';
  sDateIntervalErr = 'Bad format of date period.';
  sExpressionErr = 'Error in expression.';
  sPictureErr = 'Bad picture format.';

  // Other
  { }
  sAborted = 'Action aborted.';
  sTerminate = 'Program will terminate.';
  sNotRegist = 'Program is not registered.';
  sNotImplement = 'This action is not implemented yet.';
  sNotSupported = 'This function is not supported.';
  sVersion = 'Version';
  sAllOK = 'All OK.';
  sYes = 'Yes';
  sNo = 'No';
  sOK = 'Ok';
  sCancel = 'Cancel';

  sWrongPsw = 'Wrong password.';
  sMailErr = 'E-mail sending error.';
  sMailGenInfo = 'Generation of e-mail...';

  // ***************************************************
  // DATABASE STRING

  // DB action
  { }
  sConnecting = 'Connecting to database...';
  sLogging = 'Logging to database...';
  sInactive = 'Inactive';
  sRecord = 'record';
  sNumRecords = '%d records';
  sSelRecords = 'Selected %d records.';

  // DB questions
  { }
  sDelRecordQ = 'Delete selected record?';
  sDelMultipleRecordQ = 'Delete all selected records?';

  // DB error
  { }
  sConnectDataErr = 'Connection to database "%s" failed.';
  sCreateDataErr = 'Error: Cannot create data.';
  sOpenDataErr = 'Error: Cannot open data.';
  sReadDataErr = 'Error: Cannot read data.';
  sSaveDataErr = 'Error: Cannot save data.';
  sCompressDataErr = 'Error: Cannot compress data.';
  sExportDataErr = 'Error: Cannot export data.';
  sImportDataErr = 'Error: Cannot import data.';
  sDecodeDataErr = 'Cannot decode data.';
  sSaveRecordErr = 'Error: Cannot save record.';
  sOpenTableErr = 'Error: Cannot open table "%s".';
  sEditRecordErr = 'Error: Cannot edit record.';
  sSortDataErr = 'Error: Sorting of data.';
  sNoSavedItems = 'no saved items';
  sInputItemName = 'Name of saved item:';

  // Find results
  { }
  sNotFound = 'Not found';
  sFound = 'Found';

  sFilterName = 'Filter name';
  sFilterString = 'Filter condition';

  sEndEditing = 'Finish editing of record.';

  // ***************************************************
  // UNIT rdlg

  { }
  sInformation = 'Information';
  sQuestion = 'Question';
  sWarning = 'Warning';
  sInput = 'Input';
  sError = 'Error';
  sBtOk = '&Ok';
  sBtYes = '&Yes';
  sBtNo = '&No';
  sBtCancel = '&Cancel';
  sCut = 'Cut';
  sCopy = 'Copy';
  sPaste = 'Paste';
  sDelete = 'Delete';
  sUndo = 'Undo';
  sSelectAll = 'Select all';
  sSaveToFile = 'Save to file...';
  sLoadFromFile = 'Load from file...';
  sFind = 'Find';
  sFindNext = 'Find next';
  sChangeFont = 'Change font';
  sAbort = 'Abort';

  // ***************************************************
  // UNIT RTFReport

  { }
  sReport = 'Report';
  sTemplateFormatErr = 'Bad format of template file.';
  sPrinterNotFound = 'Printer "%s" not found.';

  sTemplateBracketErr = 'Bracket error in function: "%s".';
  sTemplateFieldErr = 'Calculation error in database field "%s".';
  sTemplateDatasetErr = 'Incorrect dataset "%s", (A..Z allowed)';
  sTemplateTagNotFoundErr = '"%s" not found.';
  sTemplateCalculationErr = 'Calculation error in function "%s".';
  sTemplateIncorrectTag = 'Incorrect tag "%s".';

  sCreatingReport = 'Creating of report...';
  sCreatingReportErr = 'Error during creating of report.';
  sFileGeneration = 'Generation of file %s...';
  sPDFWaitAgainQ = 'Output file is not generated yet. Do you want to still wait?';
  sPDFConfiguration = 'PDF printer configuration...';
  sPDFConfigurationErr = 'Error during PDF printer configuration.';
  sDeleteOldFileErr = 'Output file %s already exists and cannot be overwritten.';

  // OLE
  sMSWordNotFound = 'MSWord application not found.';
  sMSWordError = 'MSWord application error.';
  sMSExcelNotFound = 'MSExcel application not found.';
  sMSExcelError = 'MSExcel application error.';
  sMSExcelRunningToClose = 'Creted MSExcel application will be closed and file was changed. Save changes?';

  // ***************************************************
  // rDBGrid unit
  { }
  sPMSum = 'Sum = %sum';
  sPMMin = 'Min = %min';
  sPMMax = 'Max = %max';
  sPMAvg = 'Avg = %avg';
  sPMCountVal = 'Count of values = %CountVal';
  sPMCountNull = 'Count of empty = %CountNull';
  sPMCountAll = 'Count of all = %CountAll';

  sSelectAllRecords = 'Select all records';
  sDeselectAllRecords = 'Deselect all records';
  sReverseSelection = 'Reverse selection';
  sDeleteSelectedRecords = 'Delete selected records';
  sNoRecordsSelected = 'No record selected.';
  sSelectedNumRecContinueQ = 'There was already selected %d records, continue?';

  sCellParamsCondErr='Invalid condition for field %s. Condition will be deactivated.';
  sCellParamsCondStart='start by';
  sCellParamsCondNotStart='not start by';
  sCellParamsCondContain='contain';
  sCellParamsCondNotContain='not contain';
  sCellParamsCondAllways='always';
  sCellParamsActSet='>>>';
  sCellParamsActAND='AND';
  sCellParamsActOR='OR';

  sFilterSelectAll = '(select all)';
  sFilterNullValue = '(empty)';
  sIndicatorColumnName = '- Row header -';

  // ***************************************************
  // rDBComponent unit
  { }
  sPictureEmpty = '(empty)';
  sPictureCorrupted = '(corrupted)';
  sSaveInJPEGFormat = 'Store in JPG format';
  sPictureResize = 'Change resolution';
  sResizeRatioQ = 'Requested size in percentage (1% - 500%):';
  sZoomAutoFit = 'Zoom - to window';
  sZoomIn = 'Zoom in';
  sZoomOut = 'Zoom out';
  sZoom = 'Zoom';
  sShowPicEdit = 'Edit in new window (brightness, contrast)';
  sPicConvert = 'Convert...';
  sPicConvertJPG1 = 'current record to JPG';
  sPicConvertBMP1 = 'current record to BMP';
  sPicConvertJPGAll = 'all records to JPG';
  sPicConvertBMPAll = 'all records to BMP';
  sPicConvertAllQ = 'This action change format of this field for all records in table.';
  sPicConvertProcess = 'Converting...';
  sBlobOpen = 'Open';
  sBlobLoad = 'Load';
  sBlobSave = 'Save';
  sBlobClear = 'Clear';
  sBlobRename = 'Change filename';
  sBlobChangeExtQ = 'Do you want to change file type (extension)? This change can affect readibility of the file.';
  sBlobFileOverLimitQ = 'Size of selected file (%f MB) exceed set limit (%f MB).';

  sFormatInfo = 'Format selected text';
  sFormatBold = 'Bold';
  sFormatItalic = 'Italic';
  sFormatUnderline = 'Underline';
  sFormatAsUnnumberedList='Unnumbered list';
  sFormatAsNumberedList='Numbered list';
  sFormatNewPage = 'Insert end of page';
  sFormatNewLine2 = 'Insert end of line';
  sFormatNewLineAuto='Insert end of all lines';
  sFormatHorLine = 'Insert horizontal line';
  sFormatHTMLLink = 'Insert HTML link';
  sFormatClear = 'Clear all formats';
  sEditInfo = 'Show in window';

  // ***************************************************
  // rDBMemoGrid unit
  { }
  mnDelRow = 'Delete row';
  mnMoveUpRow = 'Move row up';
  mnMoveDownRow = 'Move row down';
  mnCopyCell = 'Copy cell';
  mnPasteCell = 'Paste cell';
  mnCopyTable = 'Copy whole table';
  mnPasteTable = 'Paste whole table';
  mnAppendTable = 'Add whole table';
  mnClearTable = 'Clear table';
  mnSelectRow = 'Select row';
  mnSelectAll = 'Select all rows';
  mnSelectCol = 'Select column';
  mnSelectCell = 'Select cell';
  mnDeselectAll = 'Cancel selection';

  // ***************************************************
  // rDBPrint unit
  { }
  sPrintToomuchCols = 'Data to print is too wide, unselect some columns or select smaller font size.';
  sPrintRecCount='Total count of records: %d';
  sPrintPreviewLimit = 'Preview is limited to 60 pages.';

  // ***************************************************
  // rpictool unit
  { }
  sColorBlack = 'Black';
  sColorBlackLoc = 'Black';
  sColorMaroon = 'Maroon';
  sColorMaroonLoc = 'Maroon';
  sColorGreen = 'Green';
  sColorGreenLoc = 'Green';
  sColorOlive = 'Olive';
  sColorOliveLoc = 'Olive';
  sColorNavy = 'Navy';
  sColorNavyLoc = 'Navy';
  sColorPurple = 'Purple';
  sColorPurpleLoc = 'Purple';
  sColorTeal = 'Teal';
  sColorTealLoc = 'Teal';
  sColorGray = 'Gray';
  sColorGrayLoc = 'Gray';
  sColorSilver = 'Silver';
  sColorSilverLoc = 'Silver';
  sColorRed = 'Red';
  sColorRedLoc = 'Red';
  sColorLime = 'Lime';
  sColorLimeLoc = 'Lime';
  sColorYellow = 'Yellow';
  sColorYellowLoc = 'Yellow';
  sColorBlue = 'Blue';
  sColorBlueLoc = 'Blue';
  sColorFuchsia = 'Fuchsia';
  sColorFuchsiaLoc = 'Fuchsia';
  sColorAqua = 'Aqua';
  sColorAquaLoc = 'Aqua';
  sColorWhite = 'White';
  sColorWhiteLoc = 'White';

  sColorMoneyGreen = 'MoneyGreen';
  sColorMoneyGreenLoc = 'Money Green';
  sColorSkyBlue = 'SkyBlue';
  sColorSkyBlueLoc = 'Sky Blue';
  sColorCream = 'Cream';
  sColorCreamLoc = 'Cream';
  sColorMedGray = 'MedGray';
  sColorMedGrayLoc = 'Med Gray';

  sColorCustom = 'Custom...';
  sColorCustomLoc = 'Custom...';

implementation

end.
