unit rzip_dll;
{<
  rzip_dll contains interface utility for easy using of rzip.dll library.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Apr 2014)
  @lastmod(Oct 2014)
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  rzip_TOpenArchive = function(ZipFile: PChar): integer; stdcall;
  rzip_TCloseArchive = function(Save: boolean): integer; stdcall;
  rzip_TGetFileList = function(var ListText: PChar): integer; stdcall;

  rzip_TExtractAllFiles = function(OutputPath: PChar): integer; stdcall;
  rzip_TExtractFile = function(ExtractFile, OutputFile: PChar): integer; stdcall;
  rzip_TExtractToBuffer = function(ExtractFile: PChar; Buffer: Pointer; var Length: Int64): integer; stdcall;
  rzip_TExtractContent = function(ExtractFile: PChar; var Content: PChar): integer; stdcall;

  rzip_TAddFile = function(NewFile, InputFile: PChar): integer; stdcall;
  rzip_AddFromBuffer = function(NewFile: PChar; Buffer: Pointer; Length: Int64): integer; stdcall;
  rzip_TAddContent = function(NewFile, Content: PChar): integer; stdcall;
  rzip_GetLastErrorMsg = function: PChar; stdcall;

  Trzip_interface = record
    Loaded: boolean;
    OpenArchive: rzip_TOpenArchive;
    CloseArchive: rzip_TCloseArchive;
    GetFileList: rzip_TGetFileList;
    ExtractAllFiles: rzip_TExtractAllFiles;
    ExtractFile: rzip_TExtractFile;
    ExtractToBuffer: rzip_TExtractToBuffer;
    ExtractContent: rzip_TExtractContent;
    AddFile: rzip_TAddFile;
    AddFromBuffer: rzip_AddFromBuffer;
    AddContent: rzip_TAddContent;
    GetLastErrorMsg: rzip_GetLastErrorMsg;
    procedure LoadDll;
    procedure UnloadDll;
  end;

var
  rzip: Trzip_interface;

implementation

uses rtool, rdlg, rstring;

const
  DLLFileName = 'rzip.dll';

var
  DLLHandle: THandle;

procedure Trzip_interface.LoadDll;
begin
  DLLHandle:=LoadLibrary(DLLFileName);
  if DLLHandle <= 0 then
    DlgE(Format(sDLLNotFound, [DLLFileName]))
  else
  begin
    @rzip.OpenArchive:=GetProcAddress(DLLHandle, 'OpenArchive');
    @rzip.CloseArchive:=GetProcAddress(DLLHandle, 'CloseArchive');
    @rzip.GetFileList:=GetProcAddress(DLLHandle, 'GetFileList');
    @rzip.ExtractAllFiles:=GetProcAddress(DLLHandle, 'ExtractAllFiles');
    @rzip.ExtractFile:=GetProcAddress(DLLHandle, 'ExtractFile');
    @rzip.ExtractToBuffer:=GetProcAddress(DLLHandle, 'ExtractToBuffer');
    @rzip.ExtractContent:=GetProcAddress(DLLHandle, 'ExtractContent');
    @rzip.AddFile:=GetProcAddress(DLLHandle, 'AddFile');
    @rzip.AddFromBuffer:=GetProcAddress(DLLHandle, 'AddFromBuffer');
    @rzip.AddContent:=GetProcAddress(DLLHandle, 'AddContent');
    @rzip.GetLastErrorMsg:=GetProcAddress(DLLHandle, 'GetLastErrorMsg');
    rzip.Loaded:=true;
  end;
end;

procedure Trzip_interface.UnloadDll;
begin
  FreeLibrary(DLLHandle);
  DLLHandle:=0;
  rzip.Loaded:=false;
end;

initialization

rzip.Loaded:=false;

end.
