unit fr_filedir;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, ToolWin, ShellCtrls, rShellComps, edit_baseform,
  PropSaveMain;

type
  TfrFileDir = class(TFrame)
    pmView: TPopupMenu;
    pmViewIcon: TMenuItem;
    pmViewList: TMenuItem;
    pmViewDetail: TMenuItem;
    ToolBarFileDir: TToolBar;
    tbDirBack: TToolButton;
    tbDirOrig: TToolButton;
    tbSep1: TToolButton;
    tbDirExplorer: TToolButton;
    tbSep2: TToolButton;
    tbDirPaste: TToolButton;
    tbSep3: TToolButton;
    tbDirShow: TToolButton;
    procedure tbDirBackClick(Sender: TObject);
    procedure tbDirOrigClick(Sender: TObject);
    procedure tbDirExplorerClick(Sender: TObject);
    procedure tbDirPasteClick(Sender: TObject);
    procedure pmViewIconClick(Sender: TObject);
  private
    { Private declarations }
    LV: TrShellListView;
    F: TEditBaseForm;
  public
    { Public declarations }
    procedure LinkFileDir(EditForm: TEditBaseForm; FileListView: TrShellListView);
  end;

implementation

{$R *.dfm}
uses rtool, dm_res;

procedure TfrFileDir.LinkFileDir(EditForm: TEditBaseForm; FileListView: TrShellListView);
begin
  F:=EditForm;
  LV:=FileListView;
  LV.ViewStyle:=TViewStyle(DMRes.PSFile.ReadInteger('FileListView', 'ViewStyle', 2));
end;

procedure TfrFileDir.pmViewIconClick(Sender: TObject);
begin
  LV.SetRootEx(LV.RootFolder.PathName);
  case (Sender as TMenuItem).Tag of
    0:
      LV.ViewStyle:=vsIcon;
    1:
      LV.ViewStyle:=vsList;
    2:
      LV.ViewStyle:=vsReport;
  end;
  DMRes.PSFile.WriteInteger('FileListView', 'ViewStyle', ord(LV.ViewStyle));
end;

procedure TfrFileDir.tbDirBackClick(Sender: TObject);
begin
  LV.GoBackEx(F.RootLinkedFileDir);
end;

procedure TfrFileDir.tbDirExplorerClick(Sender: TObject);
begin
  RunFileSimple(LV.RootFolder.PathName);
end;

procedure TfrFileDir.tbDirOrigClick(Sender: TObject);
begin
  LV.SetRootEx(F.LinkedFileDir);
end;

procedure TfrFileDir.tbDirPasteClick(Sender: TObject);
begin
  try
    PasteFiles(SetEndOfPath(LV.RootFolder.PathName));
  finally
    LV.Refresh;
  end;
end;

end.
